Index: /trunk/LMDZ.GENERIC/README
===================================================================
--- /trunk/LMDZ.GENERIC/README	(revision 1528)
+++ /trunk/LMDZ.GENERIC/README	(revision 1529)
@@ -1152,2 +1152,13 @@
 - Got rid of references to "control_mod" from the physics. Added a couple
   of relevent variables for outputs in time_phylmdz_mod.
+
+== 05/04/2016 == EM
+- Got rid of references to "dimensions.h" from physics packages:
+  use nbp_lon (=iim), nbp_lat (=jjp1) and nbp_lev 
+  from module mod_grid_phy_lmdz (in phy_common) instead.
+- Removed module "comhdiff_mod.F90", as it is only used by module
+  surf_heat_transp_mod.F90, moved module variables there.
+- Addedin "surf_heat_transp_mod" local versions of some arrays
+  and routines (from dyn3d) required to compute gradient, divergence, etc. 
+  on the global dynamics grid.
+  As before, the slab ocean only works in serial.
Index: /trunk/LMDZ.GENERIC/libf/dynlonlat_phylonlat/phystd/iniphysiq_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dynlonlat_phylonlat/phystd/iniphysiq_mod.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/dynlonlat_phylonlat/phystd/iniphysiq_mod.F90	(revision 1529)
@@ -4,5 +4,5 @@
 
 subroutine iniphysiq(ii,jj,nlayer,punjours, pdayref,ptimestep,           &
-                     rlatu,rlatv,rlonu,rlonv,aire,cu,cv,                 &
+               rlatudyn,rlatvdyn,rlonudyn,rlonvdyn,airedyn,cudyn,cvdyn,  &
                      prad,pg,pr,pcpp,iflag_phys)
 
@@ -21,4 +21,5 @@
                        rlond, & ! longitudes
                        rlatd ! latitudes
+use surf_heat_transp_mod, only: ini_surf_heat_transp
 use infotrac, only : nqtot ! number of advected tracers
 use planete_mod, only: ini_planete_mod
@@ -29,7 +30,10 @@
                               north_east, north_west, &
                               south_west, south_east
+use ioipsl_getin_p_mod, only: getin_p
 
 implicit none
 include "dimensions.h"
+include "paramet.h"
+include "comgeom.h"
 include "iniprint.h"
 
@@ -43,11 +47,11 @@
 integer,intent(in) :: ii ! number of atmospheric coulumns along longitudes
 integer,intent(in) :: jj  ! number of atompsheric columns along latitudes
-real,intent(in) :: rlatu(jj+1) ! latitudes of the physics grid
-real,intent(in) :: rlatv(jj) ! latitude boundaries of the physics grid
-real,intent(in) :: rlonv(ii+1) ! longitudes of the physics grid
-real,intent(in) :: rlonu(ii+1) ! longitude boundaries of the physics grid
-real,intent(in) :: aire(ii+1,jj+1) ! area of the dynamics grid (m2)
-real,intent(in) :: cu((ii+1)*(jj+1)) ! cu coeff. (u_covariant = cu * u)
-real,intent(in) :: cv((ii+1)*jj) ! cv coeff. (v_covariant = cv * v)
+real,intent(in) :: rlatudyn(jj+1) ! latitudes of the physics grid
+real,intent(in) :: rlatvdyn(jj) ! latitude boundaries of the physics grid
+real,intent(in) :: rlonvdyn(ii+1) ! longitudes of the physics grid
+real,intent(in) :: rlonudyn(ii+1) ! longitude boundaries of the physics grid
+real,intent(in) :: airedyn(ii+1,jj+1) ! area of the dynamics grid (m2)
+real,intent(in) :: cudyn((ii+1)*(jj+1)) ! cu coeff. (u_covariant = cu * u)
+real,intent(in) :: cvdyn((ii+1)*jj) ! cv coeff. (v_covariant = cv * v)
 integer,intent(in) :: pdayref ! reference day of for the simulation
 real,intent(in) :: ptimestep !physics time step (s)
@@ -60,4 +64,5 @@
 real :: total_area_phy, total_area_dyn
 real :: pi
+logical :: ok_slab_ocean
 
 ! boundaries, on global grid
@@ -99,49 +104,49 @@
   
 DO i=1,ii
-   boundslon_reg(i,east)=rlonu(i) 
-   boundslon_reg(i,west)=rlonu(i+1) 
+   boundslon_reg(i,east)=rlonudyn(i) 
+   boundslon_reg(i,west)=rlonudyn(i+1) 
 ENDDO
 
 boundslat_reg(1,north)= PI/2 
-boundslat_reg(1,south)= rlatv(1)
+boundslat_reg(1,south)= rlatvdyn(1)
 DO j=2,jj
-   boundslat_reg(j,north)=rlatv(j-1) 
-   boundslat_reg(j,south)=rlatv(j) 
+   boundslat_reg(j,north)=rlatvdyn(j-1) 
+   boundslat_reg(j,south)=rlatvdyn(j) 
 ENDDO
-boundslat_reg(jj+1,north)= rlatv(jj) 
+boundslat_reg(jj+1,north)= rlatvdyn(jj) 
 boundslat_reg(jj+1,south)= -PI/2
 
 ! Write values in module regular_lonlat_mod
-CALL init_regular_lonlat(ii,jj+1, rlonv(1:ii), rlatu, &
+CALL init_regular_lonlat(ii,jj+1, rlonvdyn(1:ii), rlatudyn, &
                          boundslon_reg, boundslat_reg)
 
 ! Generate global arrays on full physics grid
 allocate(latfi(klon_glo),lonfi(klon_glo),cufi(klon_glo),cvfi(klon_glo))
-latfi(1)=rlatu(1)
+latfi(1)=rlatudyn(1)
 lonfi(1)=0.
-cufi(1) = cu(1)
-cvfi(1) = cv(1)
+cufi(1) = cudyn(1)
+cvfi(1) = cvdyn(1)
 DO j=2,jj
   DO i=1,ii
-    latfi((j-2)*ii+1+i)= rlatu(j)
-    lonfi((j-2)*ii+1+i)= rlonv(i)
-    cufi((j-2)*ii+1+i) = cu((j-1)*(ii+1)+i)
-    cvfi((j-2)*ii+1+i) = cv((j-1)*(ii+1)+i)
+    latfi((j-2)*ii+1+i)= rlatudyn(j)
+    lonfi((j-2)*ii+1+i)= rlonvdyn(i)
+    cufi((j-2)*ii+1+i) = cudyn((j-1)*(ii+1)+i)
+    cvfi((j-2)*ii+1+i) = cvdyn((j-1)*(ii+1)+i)
   ENDDO
 ENDDO
-latfi(klon_glo)= rlatu(jj+1)
+latfi(klon_glo)= rlatudyn(jj+1)
 lonfi(klon_glo)= 0.
-cufi(klon_glo) = cu((ii+1)*jj+1)
-cvfi(klon_glo) = cv((ii+1)*jj-ii)
+cufi(klon_glo) = cudyn((ii+1)*jj+1)
+cvfi(klon_glo) = cvdyn((ii+1)*jj-ii)
 
 ! build airefi(), mesh area on physics grid
 allocate(airefi(klon_glo))
-CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,aire,airefi)
+CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,airedyn,airefi)
 ! Poles are single points on physics grid
-airefi(1)=sum(aire(1:ii,1))
-airefi(klon_glo)=sum(aire(1:ii,jj+1))
+airefi(1)=sum(airedyn(1:ii,1))
+airefi(klon_glo)=sum(airedyn(1:ii,jj+1))
 
 ! Sanity check: do total planet area match between physics and dynamics?
-total_area_dyn=sum(aire(1:ii,1:jj+1))
+total_area_dyn=sum(airedyn(1:ii,1:jj+1))
 total_area_phy=sum(airefi(1:klon_glo))
 IF (total_area_dyn/=total_area_phy) THEN
@@ -174,4 +179,13 @@
 call ini_planete_mod(nlayer,preff,ap,bp)
 
+! for slab ocean, copy over some arrays
+ok_slab_ocean=.false. ! default value
+call getin_p("ok_slab_ocean",ok_slab_ocean)
+if (ok_slab_ocean) then
+  call ini_surf_heat_transp(ip1jm,ip1jmp1,unsairez,fext,unsaire, &
+                            cu,cuvsurcv,cv,cvusurcu,aire,apoln,apols, &
+                            aireu,airev)
+endif
+
 ! copy some fundamental parameters to physics 
 ! and do some initializations 
Index: /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 1529)
@@ -31,7 +31,4 @@
 !     Varying nueff section removed by R. Wordsworth for simplicity
 !     ==============================================================
-
-!#include "dimensions.h"
-!#include "dimphys.h"
 
 !     Local variables 
Index: /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 1529)
@@ -19,6 +19,6 @@
       USE tracer_h
       use comcstfi_mod, only: pi, mugaz, cpp
-      use callkeys_mod, only: varactive,diurnal,tracer,water,nosurf,varfixed,satval,	&
-		              kastprof,strictboundcorrk,specOLR,CLFvarying
+      use callkeys_mod, only: varactive,diurnal,tracer,water,nosurf,varfixed,satval,        &
+                              kastprof,strictboundcorrk,specOLR,CLFvarying
 
       implicit none
@@ -144,14 +144,11 @@
 
       ! Local aerosol optical properties for each column on RADIATIVE grid.
-      real*8,save ::  QXVAER(L_LEVELS+1,L_NSPECTV,naerkind)
-      real*8,save ::  QSVAER(L_LEVELS+1,L_NSPECTV,naerkind)
-      real*8,save ::  GVAER(L_LEVELS+1,L_NSPECTV,naerkind)
-      real*8,save ::  QXIAER(L_LEVELS+1,L_NSPECTI,naerkind)
-      real*8,save ::  QSIAER(L_LEVELS+1,L_NSPECTI,naerkind)
-      real*8,save ::  GIAER(L_LEVELS+1,L_NSPECTI,naerkind)
-
-      !REAL :: QREFvis3d(ngrid,nlayer,naerkind)
-      !REAL :: QREFir3d(ngrid,nlayer,naerkind)
-      !save QREFvis3d, QREFir3d 
+      real*8,save,allocatable ::  QXVAER(:,:,:)
+      real*8,save,allocatable ::  QSVAER(:,:,:)
+      real*8,save,allocatable ::  GVAER(:,:,:)
+      real*8,save,allocatable ::  QXIAER(:,:,:)
+      real*8,save,allocatable ::  QSIAER(:,:,:)
+      real*8,save,allocatable ::  GIAER(:,:,:)
+
       real, dimension(:,:,:), save, allocatable :: QREFvis3d
       real, dimension(:,:,:), save, allocatable :: QREFir3d
@@ -188,13 +185,13 @@
 
 
-      qxvaer(:,:,:)=0.0
-      qsvaer(:,:,:)=0.0
-      gvaer(:,:,:) =0.0
-
-      qxiaer(:,:,:)=0.0
-      qsiaer(:,:,:)=0.0
-      giaer(:,:,:) =0.0
-
       if(firstcall) then
+
+        ! test on allocated necessary because of CLFvarying (two calls to callcorrk in physiq)
+        if(.not.allocated(QXVAER)) allocate(QXVAER(L_LEVELS+1,L_NSPECTV,naerkind))
+        if(.not.allocated(QSVAER)) allocate(QSVAER(L_LEVELS+1,L_NSPECTV,naerkind))
+        if(.not.allocated(GVAER)) allocate(GVAER(L_LEVELS+1,L_NSPECTV,naerkind))
+        if(.not.allocated(QXIAER)) allocate(QXIAER(L_LEVELS+1,L_NSPECTI,naerkind))
+        if(.not.allocated(QSIAER)) allocate(QSIAER(L_LEVELS+1,L_NSPECTI,naerkind))
+        if(.not.allocated(GIAER)) allocate(GIAER(L_LEVELS+1,L_NSPECTI,naerkind))
 
          !!! ALLOCATED instances are necessary because of CLFvarying (strategy to call callcorrk twice in physiq...)
@@ -212,5 +209,5 @@
          endif
          call su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
-	 
+         
          
 !--------------------------------------------------
@@ -264,10 +261,16 @@
       end if ! of if (firstcall)
 
-
 !=======================================================================
 !          I.b  Initialization on every call   
 !=======================================================================
  
- 
+      qxvaer(:,:,:)=0.0
+      qsvaer(:,:,:)=0.0
+      gvaer(:,:,:) =0.0
+
+      qxiaer(:,:,:)=0.0
+      qsiaer(:,:,:)=0.0
+      giaer(:,:,:) =0.0
+
 !--------------------------------------------------
 !     Effective radius and variance of the aerosols
@@ -277,11 +280,11 @@
 
          if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! Treat condensed co2 particles.
-	    call co2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_co2))
+            call co2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_co2))
             print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
             print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
-	 end if
+         end if
          
          if ((iaer.eq.iaero_h2o).and.water) then ! Treat condensed water particles. To be generalized for other aerosols ...
-	    call h2o_reffrad(ngrid,nlayer,pq(1,1,igcm_h2o_ice),pt, &
+            call h2o_reffrad(ngrid,nlayer,pq(1,1,igcm_h2o_ice),pt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
             print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
@@ -290,15 +293,15 @@
          
          if(iaer.eq.iaero_dust)then
-	    call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
+            call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
             print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          
          if(iaer.eq.iaero_h2so4)then
-	    call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
+            call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
             print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          
           if(iaer.eq.iaero_back2lay)then
-	    call back2lay_reffrad(ngrid,reffrad(1,1,iaero_back2lay),nlayer,pplev)
+            call back2lay_reffrad(ngrid,reffrad(1,1,iaero_back2lay),nlayer,pplev)
          endif
          
@@ -321,5 +324,5 @@
            reffrad,QREFvis3d,QREFir3d,                             & 
            tau_col,cloudfrac,totcloudfrac,clearsky)                
-	  
+          
 
 
@@ -475,14 +478,14 @@
          DO nw=1,L_NSPECTV ! Short Wave loop.
             albv(nw)=albedo(ig,nw)
-	 ENDDO
+         ENDDO
 
          if (nosurf) then ! Case with no surface.
             DO nw=1,L_NSPECTV
                if(albv(nw).gt.0.0) then
-	          print*,'For open lower boundary in callcorrk must'
+                  print*,'For open lower boundary in callcorrk must'
                   print*,'have spectral surface band albedos all set to zero!'
                   call abort
-	       endif
-	    ENDDO         
+               endif
+            ENDDO         
          endif
 
@@ -770,5 +773,5 @@
 
          Cmk= 0.01 * 1.0 / (glat(ig) * mugaz * 1.672621e-27) ! q_main=1.0 assumed.
-	 glat_ig=glat(ig)
+         glat_ig=glat(ig)
 
 !-----------------------------------------------------------------------
@@ -798,5 +801,5 @@
          else ! During the night, fluxes = 0.
             nfluxtopv       = 0.0d0
-	    fluxtopvdn      = 0.0d0
+            fluxtopvdn      = 0.0d0
             nfluxoutv_nu(:) = 0.0d0
             nfluxgndv_nu(:) = 0.0d0
@@ -813,15 +816,15 @@
             surface_stellar_flux=sum(nfluxgndv_nu(1:L_NSPECTV))      
             if(surface_stellar_flux .gt. 1.0e-3) then ! equivalent albedo makes sense only if the stellar flux received by the surface is positive.
-	       DO nw=1,L_NSPECTV	          
-	          albedo_temp(nw)=albedo(ig,nw)*nfluxgndv_nu(nw)
+               DO nw=1,L_NSPECTV                  
+                  albedo_temp(nw)=albedo(ig,nw)*nfluxgndv_nu(nw)
                ENDDO
-	       albedo_temp(1:L_NSPECTV)=albedo_temp(1:L_NSPECTV)/surface_stellar_flux
+               albedo_temp(1:L_NSPECTV)=albedo_temp(1:L_NSPECTV)/surface_stellar_flux
                albedo_equivalent(ig)=sum(albedo_temp(1:L_NSPECTV))
             else
                albedo_equivalent(ig)=0.0 ! Spectrally Integrated Albedo not defined for non-irradiated grid points. So we arbitrary set the equivalent albedo to 0.
             endif
-	 else
-	    albedo_equivalent(ig)=0.0 ! Spectrally Integrated Albedo not defined for non-irradiated grid points. So we arbitrary set the equivalent albedo to 0.
-	 endif
+         else
+            albedo_equivalent(ig)=0.0 ! Spectrally Integrated Albedo not defined for non-irradiated grid points. So we arbitrary set the equivalent albedo to 0.
+         endif
 
 
@@ -956,5 +959,5 @@
         IF( ALLOCATED( pfgasref ) ) DEALLOCATE( pfgasref )
 !$OMP END MASTER
-!$OMP BARRIER	
+!$OMP BARRIER
         IF ( ALLOCATED(reffrad)) DEALLOCATE(reffrad)
         IF ( ALLOCATED(nueffrad)) DEALLOCATE(nueffrad)
Index: /trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F	(revision 1529)
@@ -907,22 +907,3 @@
       end                       !rcm1d
  
-c***********************************************************************
-c***********************************************************************
-c     Subroutines Bidons utilise seulement en 3D, mais
-c     necessaire a la compilation de rcm1d en 1D
-
-!      subroutine gr_fi_dyn
-!      RETURN
-!      END
- 
-c***********************************************************************
-c***********************************************************************
-
-!#include "../dyn3d/disvert.F"
-!#include "../dyn3d/abort_gcm.F"
-!#include "../dyn3d/diverg.F"
-!#include "../dyn3d/grad.F"
-!#include "../dyn3d/gr_u_scal.F"
-!#include "../dyn3d/gr_v_scal.F"
-!#include "../dyn3d/gr_dyn_fi.F"
-
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/inifis_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/inifis_mod.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/inifis_mod.F90	(revision 1529)
@@ -9,5 +9,6 @@
              prad,pg,pr,pcpp)
 
-  use radinc_h, only : naerkind
+  use radinc_h, only: ini_radinc_h, naerkind
+  use radcommon_h, only: ini_radcommon_h
   use datafile_mod, only: datadir
   use comdiurn_h, only: sinlat, coslat, sinlon, coslon
@@ -21,4 +22,5 @@
   use planetwide_mod, only: planetwide_sumval
   use callkeys_mod
+  use mod_phys_lmdz_para, only : is_parallel
 
 !=======================================================================
@@ -74,11 +76,4 @@
   REAL SSUM
  
-  CHARACTER ch1*12
-  CHARACTER ch80*80
-
-  logical chem, h2o
-
-  real psurf,pN2 ! added by RW for Gliese 581d N2+CO2
-
   ! initialize constants in comcstfi_mod
   rad=prad
@@ -333,4 +328,9 @@
      call getin_p("ok_slab_ocean",ok_slab_ocean)
      write(*,*) "ok_slab_ocean = ",ok_slab_ocean
+     ! Sanity check: for now slab oncean only works in serial mode
+     if (ok_slab_ocean.and.is_parallel) then
+       write(*,*) " Error: slab ocean should only be used in serial mode!"
+       call abort
+     endif
 
      write(*,*) "Use slab-sea-ice ?"
@@ -718,4 +718,10 @@
   ENDDO
 
+  ! initialize variables in radinc_h
+  call ini_radinc_h(nlayer)
+ 
+  ! allocate "radcommon_h" arrays
+  call ini_radcommon_h()
+
   ! allocate "comsoil_h" arrays
   call ini_comsoil_h(ngrid)
Index: /trunk/LMDZ.GENERIC/libf/phystd/inistats.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/inistats.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/inistats.F	(revision 1529)
@@ -1,19 +1,20 @@
       subroutine inistats(ierr)
 
+      use statto_mod, only: istats,istime
       use mod_phys_lmdz_para, only : is_master
-      use statto_mod, only: istats,istime
       USE comvert_mod, ONLY: ap,bp,aps,bps,preff,pseudoalt,presnivs
-      USE comconst_mod, ONLY: daysec,dtphys,pi
+      USE comconst_mod, ONLY: pi
+      USE time_phylmdz_mod, ONLY: daysec,dtphys
+      USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
       implicit none
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "netcdf.inc"
+      include "netcdf.inc"
 
       integer,intent(out) :: ierr
       integer :: nid
       integer :: l,nsteppd
-      real, dimension(llm) ::  sig_s
+      real, dimension(nbp_lev) ::  sig_s
+      real :: lon_reg_ext(nbp_lon+1) ! extended longitudes
       integer :: idim_lat,idim_lon,idim_llm,idim_llmp1,idim_time
       real, dimension(istime) :: lt
@@ -39,8 +40,12 @@
       write (*,*) 
 
-      do l= 1, llm
+      do l= 1, nbp_lev
          sig_s(l)=((ap(l)+ap(l+1))/preff+bp(l)+bp(l+1))/2.
          pseudoalt(l)=-10.*log(presnivs(l)/preff)   
       enddo
+      
+      lon_reg_ext(1:nbp_lon)=lon_reg(1:nbp_lon)
+      !add extra redundant point (180 degrees, since lon_reg starts at -180
+      lon_reg_ext(nbp_lon+1)=-lon_reg_ext(1)
 
       if (is_master) then
@@ -53,8 +58,8 @@
       endif
 
-      ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_lat)
-      ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_lon)
-      ierr = NF_DEF_DIM (nid, "altitude", llm, idim_llm)
-      ierr = NF_DEF_DIM (nid, "llmp1", llm+1, idim_llmp1)
+      ierr = NF_DEF_DIM (nid, "latitude", nbp_lat, idim_lat)
+      ierr = NF_DEF_DIM (nid, "longitude", nbp_lon+1, idim_lon)
+      ierr = NF_DEF_DIM (nid, "altitude", nbp_lev, idim_llm)
+      ierr = NF_DEF_DIM (nid, "llmp1", nbp_lev+1, idim_llmp1)
       ierr = NF_DEF_DIM (nid, "Time", NF_UNLIMITED, idim_time)
 
@@ -68,14 +73,14 @@
      &            "degrees_north",1,idim_lat,nvarid,ierr)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatu/pi*180)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lat_reg/pi*180)
 #else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatu/pi*180)
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lat_reg/pi*180)
 #endif
       call def_var_stats(nid,"longitude","East longitude",
      &            "degrees_east",1,idim_lon,nvarid,ierr)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonv/pi*180)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lon_reg_ext/pi*180)
 #else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonv/pi*180)
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lon_reg_ext/pi*180)
 #endif
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/initracer.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1529)
@@ -22,7 +22,4 @@
 c            Ehouarn Millour (oct. 2008) identify tracers by their names
 c=======================================================================
-
-
-#include "dimensions.h"
 
       integer :: ngrid,nq
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 1529)
@@ -1,11 +1,13 @@
-      SUBROUTINE iniwrite(nid,idayref,phis)
+      SUBROUTINE iniwrite(nid,idayref,phis,area)
 
       use comsoil_h, only: mlayer, nsoilmx
-      use comcstfi_mod, only: rad, omeg, g, mugaz, rcp, pi
-      use time_phylmdz_mod, only: daysec, dtphys
+      USE comcstfi_mod, only: g, mugaz, omeg, rad, rcp, pi 
       USE comvert_mod, ONLY: ap,bp,aps,bps,pseudoalt
       USE logic_mod, ONLY: fxyhypb,ysinus
       USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy
+      USE time_phylmdz_mod, ONLY: daysec, dtphys
       USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
+      USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
       IMPLICIT NONE
 
@@ -26,8 +28,5 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "netcdf.inc"
+      include "netcdf.inc"
 
 c   Arguments:
@@ -36,5 +35,6 @@
       integer,intent(in) :: nid        ! NetCDF file ID
       INTEGER*4,intent(in) :: idayref  ! date (initial date for this run)
-      real,intent(in) :: phis(ip1jmp1) ! surface geopotential
+      real,intent(in) :: phis(nbp_lon+1,nbp_lat) ! surface geopotential
+      real,intent(in) :: area(nbp_lon+1,nbp_lat) ! mesh area (m2)
 
 c   Local:
@@ -44,7 +44,8 @@
       REAL tab_cntrl(length) ! run parameters are stored in this array
       INTEGER ierr
-
-      integer :: nvarid,idim_index,idim_rlonu,idim_rlonv
-      integer :: idim_rlatu,idim_rlatv,idim_llmp1,idim_llm
+      REAl :: lon_reg_ext(nbp_lon+1) ! extended longitudes
+
+      integer :: nvarid,idim_index,idim_rlonv
+      integer :: idim_rlatu,idim_llmp1,idim_llm
       integer :: idim_nsoilmx ! "subsurface_layers" dimension ID #
       integer, dimension(2) :: id  
@@ -54,7 +55,7 @@
          tab_cntrl(l)=0.
       ENDDO
-      tab_cntrl(1)  = real(iim)
-      tab_cntrl(2)  = real(jjm)
-      tab_cntrl(3)  = real(llm)
+      tab_cntrl(1)  = real(nbp_lon)
+      tab_cntrl(2)  = real(nbp_lat-1)
+      tab_cntrl(3)  = real(nbp_lev)
       tab_cntrl(4)  = real(idayref)
       tab_cntrl(5)  = rad
@@ -99,10 +100,10 @@
 
       ierr = NF_DEF_DIM (nid, "index", length, idim_index)
-      ierr = NF_DEF_DIM (nid, "rlonu", iip1, idim_rlonu)
-      ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_rlatu)
-      ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_rlonv)
-      ierr = NF_DEF_DIM (nid, "rlatv", jjm, idim_rlatv)
-      ierr = NF_DEF_DIM (nid, "interlayer", (llm+1), idim_llmp1)
-      ierr = NF_DEF_DIM (nid, "altitude", llm, idim_llm)
+!      ierr = NF_DEF_DIM (nid, "rlonu", iip1, idim_rlonu)
+      ierr = NF_DEF_DIM (nid, "latitude", nbp_lat, idim_rlatu)
+      ierr = NF_DEF_DIM (nid, "longitude", nbp_lon+1, idim_rlonv)
+!      ierr = NF_DEF_DIM (nid, "rlatv", jjm, idim_rlatv)
+      ierr = NF_DEF_DIM (nid, "interlayer", (nbp_lev+1), idim_llmp1)
+      ierr = NF_DEF_DIM (nid, "altitude", nbp_lev, idim_llm)
       ierr = NF_DEF_DIM (nid,"subsurface_layers",nsoilmx,idim_nsoilmx)
 c
@@ -129,18 +130,19 @@
 c --------------------------
 c  longitudes and latitudes
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "rlonu", NF_DOUBLE, 1, idim_rlonu,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "rlonu", NF_FLOAT, 1, idim_rlonu,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
-     .                       "Longitudes at u nodes")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonu/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonu/pi*180)
-#endif
+!
+!      ierr = NF_REDEF (nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_DEF_VAR (nid, "rlonu", NF_DOUBLE, 1, idim_rlonu,nvarid)
+!#else
+!      ierr = NF_DEF_VAR (nid, "rlonu", NF_FLOAT, 1, idim_rlonu,nvarid)
+!#endif
+!      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
+!     .                       "Longitudes at u nodes")
+!      ierr = NF_ENDDEF(nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonu/pi*180)
+!#else
+!      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonu/pi*180)
+!#endif
 c
 c --------------------------
@@ -156,10 +158,14 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatu/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatu/pi*180)
-#endif
-c
-c --------------------------
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lat_reg/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lat_reg/pi*180)
+#endif
+c
+c --------------------------
+      lon_reg_ext(1:nbp_lon)=lon_reg(1:nbp_lon)
+      !add extra redundant point (180 degrees, since lon_reg starts at -180
+      lon_reg_ext(nbp_lon+1)=-lon_reg_ext(1)
+
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -173,7 +179,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonv/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonv/pi*180)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lon_reg_ext/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lon_reg_ext/pi*180)
 #endif
 c
@@ -199,18 +205,18 @@
 c
 c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "rlatv", NF_DOUBLE, 1, idim_rlatv,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "rlatv", NF_FLOAT, 1, idim_rlatv,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
-     .                       "Latitudes at v nodes")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatv/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatv/pi*180)
-#endif
+!      ierr = NF_REDEF (nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_DEF_VAR (nid, "rlatv", NF_DOUBLE, 1, idim_rlatv,nvarid)
+!#else
+!      ierr = NF_DEF_VAR (nid, "rlatv", NF_FLOAT, 1, idim_rlatv,nvarid)
+!#endif
+!      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
+!     .                       "Latitudes at v nodes")
+!      ierr = NF_ENDDEF(nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatv/pi*180)
+!#else
+!      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatv/pi*180)
+!#endif
 c
 c --------------------------
@@ -274,40 +280,40 @@
 c  Mesh area and conversion coefficients cov. <-> contra. <--> natural
 
-      id(1)=idim_rlonu
-      id(2)=idim_rlatu
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cu", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cu", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cu)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cu)
-#endif
-c
-      id(1)=idim_rlonv
-      id(2)=idim_rlatv
-c
-c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cv", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cv", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cv)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cv)
-#endif
+!      id(1)=idim_rlonu
+!      id(2)=idim_rlatu
+c
+!      ierr = NF_REDEF (nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_DEF_VAR (nid, "cu", NF_DOUBLE, 2, id,nvarid)
+!#else
+!      ierr = NF_DEF_VAR (nid, "cu", NF_FLOAT, 2, id,nvarid)
+!#endif
+!      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
+!     .             "Conversion coefficients cov <--> natural")
+!      ierr = NF_ENDDEF(nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cu)
+!#else
+!      ierr = NF_PUT_VAR_REAL (nid,nvarid,cu)
+!#endif
+c
+!      id(1)=idim_rlonv
+!      id(2)=idim_rlatv
+c
+c --------------------------
+!      ierr = NF_REDEF (nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_DEF_VAR (nid, "cv", NF_DOUBLE, 2, id,nvarid)
+!#else
+!      ierr = NF_DEF_VAR (nid, "cv", NF_FLOAT, 2, id,nvarid)
+!#endif
+!      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
+!     .             "Conversion coefficients cov <--> natural")
+!      ierr = NF_ENDDEF(nid)
+!#ifdef NC_DOUBLE
+!      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cv)
+!#else
+!      ierr = NF_PUT_VAR_REAL (nid,nvarid,cv)
+!#endif
 c
       id(1)=idim_rlonv
@@ -325,7 +331,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aire)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,aire)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,area)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,area)
 #endif
 c
@@ -350,7 +356,8 @@
 c
 
-      write(*,*)'iniwrite: iim,jjm,llm,idayref',iim,jjm,llm,idayref
+      write(*,*)'iniwrite: nbp_lon,nbp_lat,nbp_lev,idayref',
+     & nbp_lon,nbp_lat,nbp_lev,idayref
       write(*,*)'iniwrite: rad,omeg,g,mugaz,rcp',
-     s rad,omeg,g,mugaz,rcp
+     & rad,omeg,g,mugaz,rcp
       write(*,*)'iniwrite: daysec,dtphys',daysec,dtphys
 
